package com.tidecloud.dataacceptance.service.impl;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Component;

import com.tidecloud.dataacceptance.rfid.ReaderDataPackageParser;
import com.tidecloud.dataacceptance.rfid.ReaderDataPackageProcess;
import com.tidecloud.dataacceptance.rfid.module.interaction.DataPackageParser;
import com.tidecloud.dataacceptance.rfid.module.interaction.DataPackageProcess;
import com.tidecloud.dataacceptance.rfid.rxobserver.RXObserver;
import com.tidecloud.dataacceptance.service.AcceptanceInboundHandlerAdapter;

import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelHandler;
import io.netty.channel.ChannelHandlerContext;

/**
 * @author ryan
 */
@Component
@ChannelHandler.Sharable
public class VorgeaUR0401ServerHandler extends AcceptanceInboundHandlerAdapter {

	private static final Logger logger = LoggerFactory.getLogger(VorgeaUR0401ServerHandler.class);
	

	DataPackageParser mPackageParser = new ReaderDataPackageParser();
	DataPackageProcess mPackageProcess = new ReaderDataPackageProcess();
	
	private RXObserver mObserver = new RXObserver() ;
	DateFormat fmt = new SimpleDateFormat("yyyyMMddHHmmss");

	@Override
	public void channelRead(ChannelHandlerContext ctx, Object msg) throws Exception {

		ByteBuf byteBuf = (ByteBuf) msg;
		int len = byteBuf.readableBytes();

		byte[] btAryReceiveData = new byte[len];

		byteBuf.getBytes(0, btAryReceiveData);

		mPackageProcess.addObserver(mObserver);
		
		mPackageParser.runReceiveDataCallback(btAryReceiveData, mPackageProcess);
		// String strEPC = mObserver.ge
		
		// manageChannel(ctx.channel(), phone);
		String epc = mObserver.getStrEPC();
		String deviceId = mObserver.getDeviceId();
		String storageStr = deviceId+";"+epc+";"+fmt.format(new Date());
		dataStorage(storageStr);

	}


	@Override
	public void reply(ChannelHandlerContext ctx, String msg) throws Exception {
		// TODO Auto-generated method stub
		
	}
}
